SystemOrganization addCategory: #ConfigurationOfArff!

Object subclass: #ConfigurationOfArff
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfArff'!

!ConfigurationOfArff class methodsFor: 'development support' stamp: 'JulienDelplanque 4/30/2016 17:22'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfArff class methodsFor: 'private' stamp: 'JulienDelplanque 4/30/2016 17:22'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #'ConfigurationOf'
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #'ConfigurationOf' ifAbsent: aBlock ].! !

!ConfigurationOfArff class methodsFor: 'catalog' stamp: 'JulienDelplanque 4/30/2016 17:30'!
catalogContactInfo
	^ 'julien.delplanque@live.be'! !

!ConfigurationOfArff class methodsFor: 'catalog' stamp: 'JulienDelplanque 4/30/2016 17:29'!
catalogDescription
	^ 'Framework to generate Weka''s [1] ARFF [2] formatted string from Pharo.

Links:
[1] Weka website: http://www.cs.waikato.ac.nz/ml/weka/
[2] ARFF format spec: https://weka.wikispaces.com/ARFF'! !

!ConfigurationOfArff class methodsFor: 'catalog' stamp: 'JulienDelplanque 4/30/2016 17:31'!
catalogKeywords
	^ #('weka' 'arff' 'datamining' 'datawarehousing')! !

!ConfigurationOfArff class methodsFor: 'private' stamp: 'JulienDelplanque 4/30/2016 17:22'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfArff class methodsFor: 'private' stamp: 'JulienDelplanque 4/30/2016 17:22'!
ensureMetacelloBaseConfiguration
  Smalltalk
    at: #'ConfigurationOf'
    ifAbsent: [ 
      | repository version |
      repository := MCHttpRepository
        location: 'http://smalltalkhub.com/mc/dkh/metacello/main'
        user: ''
        password: ''.
      repository
        versionReaderForFileNamed: 'Metacello-Base-dkh.107'
        do: [ :reader | 
          version := reader version.
          version load.
          version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfArff class methodsFor: 'metacello tool support' stamp: 'JulienDelplanque 4/30/2016 17:22'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfArff class methodsFor: 'loading' stamp: 'JulienDelplanque 4/30/2016 17:22'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfArff class methodsFor: 'loading' stamp: 'JulienDelplanque 4/30/2016 17:22'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfArff class methodsFor: 'loading' stamp: 'JulienDelplanque 4/30/2016 17:22'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfArff class methodsFor: 'accessing' stamp: 'JulienDelplanque 4/30/2016 17:22'!
project

	^self new project! !

!ConfigurationOfArff class methodsFor: 'development support' stamp: 'JulienDelplanque 4/30/2016 17:22'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfArff methodsFor: 'baselines' stamp: 'JulienDelplanque 4/30/2016 17:25'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec baseline: 'Arff' with: [
			spec repository: 'github://juliendelplanque/Arff/repository' ] ].
! !

!ConfigurationOfArff methodsFor: 'accessing' stamp: 'JulienDelplanque 4/30/2016 17:22'!
customProjectAttributes
    "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes "

    ^ #()! !

!ConfigurationOfArff methodsFor: 'accessing' stamp: 'JulienDelplanque 4/30/2016 17:22'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !

!ConfigurationOfArff methodsFor: 'symbolic versions' stamp: 'JulienDelplanque 4/30/2016 17:24'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.1-baseline'.
! !
